; pForthDict.asm
; Pocket Forth version of Flint  7:48:10 PM  1/12/87
; put into "DICT" resource 1:27:38 PM  1/23/87
; change DP to Dict and CP to DP 4:48:49 PM  1/24/87
; add optional base expansion 11:33:21 PM  2/3/87
; restructure 8:22:09 AM  2/11/87
; version 0.3  12:53:54 PM  1/21/88
; Fri Apr 29, 1988 10:17:36 v 0.4
; 11:55:00 PM 6/3/91 restructure preamble
; Thu Apr 02, 1992 12:00:00 grow return
; Fri Jan 22, 1993 19:28:00 0.6.2
; Fri Jun 06, 1993 05:13:00 0.6.3

WHeight	EQU	178
WWidth	EQU	384
CR	EQU	$0D
BS	EQU	8
BL	EQU	32

MACRO	Counter =	D7 |		; Character count
MACRO	Dict =	D6 |			; _DICT_ionary last word (rel.addr)
MACRO	RS =	A7 |			; _R_eturn (and system) _S_tack
MACRO	PS =	A6 |			; _P_arameter _S_tack
MACRO	IS =	A4 |			; _I_nput _S_tream
MACRO	BP =	A3 |			; _B_ase _P_ointer
MACRO	DP =	A2 |			; _D_ictionary _P_ointer

MACRO	Base =	Bottom |		; address of the bottom address
MACRO	theLink =  Base-6 |		; dictionary search link address

INCLUDE	Traps.txt
INCLUDE	Macros.txt

.ALIGN 2     ;	 TYPE	ID#   Title   attribute: locked
RESOURCE	'DICT'	257  'Pocket'	16

; ----- start of code ------

Bottom:	JMP	Cold			; first time run
GRet:	LEA	Bottom,BP		; reset the base pointer
  	LEA	0(BP,D1.W),DP		; abs.addr into register
	LEA	0(BP,D2.W),IS
	JSR	toabs-base(BP)
	MOVE.L	(PS)+,(RS)
	RTS


INCLUDE	Interface.txt			; the interface
INCLUDE Interpreter.txt			; the interpreter
INCLUDE	Dictionary.txt			; the dictionary

END
